from zope import interface
from zope import component

from . import interfaces
import types

def create(spec):
    # set up mapper
    mapper = interfaces.IMapper(spec)

    # create instance
    return mapper()

@interface.implementer(interfaces.IMapped)
@component.adapter(interface.Interface)
def createInstanceFromItem(item):
    return create(item.__class__)

@interface.implementer(interfaces.IMapped)
@component.adapter(int)
def createIntegerBasicType(int):
    return create(interfaces.IIntegerBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(float)
def createFloatBasicType(float):
    return create(interfaces.IFloatBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(str)
def createUnicodeBasicType(str):
    return create(interfaces.IUnicodeBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(bytes)
def createStringBasicType(str):
    return create(interfaces.IStringBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(tuple)
def createTupleBasicType(tuple):
    return create(interfaces.ITupleBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(list)
def createListBasicType(list):
    return create(interfaces.IListBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(type(set()))
def createSetBasicType(set):
    return create(interfaces.ISetBasicType)

@interface.implementer(interfaces.IMapped)
@component.adapter(dict)
def createDictBasicType(dict):
    return create(interfaces.IDictBasicType)


